import { reduce } from './reduce.js';
import { chunk } from './chunk.js';
import { map } from './map.js';
import { head } from './head.js';
import { pipe } from './pipe.js';
export function average() {
    return function averageFn(data) {
        const program = pipe(reduce((acc, current) => {
            acc[0] += current;
            acc[1] += 1;
            return acc;
        }, [0, 0]), chunk(2), map(([sum, count]) => sum / count), head());
        return program(data);
    };
}
// Alias
export const mean = average;
